import sys, os
sys.path.append(os.path.abspath(os.path.dirname(sys.argv[0]))+"/../") 

import math

class IntUtil:

    @staticmethod
    def bytes2int(bytes):
        """Converts a list of bytes or a string to an integer

        >>> (128*256 + 64)*256 + + 15
        8405007
        >>> l = [128, 64, 15]
        >>> IntUtil.bytes2int(l)
        8405007
        """


        # Convert byte stream to integer
        integer = 0
        for byte in bytes:
            integer *= 256
            if isinstance(byte, basestring): byte = ord(byte)
            integer += byte

        return integer
 
    @staticmethod
    def int2bytes(number):
        """Converts a number to a string of bytes
        
        >>> IntUtil.bytes2int(IntUtil.int2bytes(123456789))
        123456789
        """

        string = ""

        while number > 0:
            string = "%s%s" % (chr(number & 0xFF), string)
            number /= 256
        
        return string
 
    @staticmethod
    def bits2bytes(bits):
        """Given _bits_ bits, return minimum number of bytes that will hold that many 
        bits
        
        >>> IntUtil.bits2bytes(0)
        0
        >>> IntUtil.bits2bytes(1)
        1
        >>> IntUtil.bits2bytes(5)
        1
        >>> IntUtil.bits2bytes(33)
        5
        """
        
        return int(math.ceil(bits/8.))

if __name__ == "__main__":
    import doctest
    doctest.testmod()    

    #print RSAUtil.ExtendedEuclidean(120,23)
