

import sys, os
sys.path.append(os.path.abspath(os.path.dirname(sys.argv[0]))+"/../") 

import hmac, sha
import os
import math
import binascii

from IntUtil import IntUtil


class Random:
    def __init__(self):
        self.seed = None
        self.i = None

    def Seed(self, s):
        """
        Seed the random number generator. This should be called with os.urandom(32) as the seed        
        
        """
        self.seed = s
        self.i = 0
    
    def GetSeed(self):
        return self.seed
        
    def RandInt(self, bytes):
        """Return an integer with bytes random bytes"""
        return IntUtil.bytes2int(self.RandBytes(bytes))
        
    def RandBytes(self, bytes):
        """
        Return 'bytes' random bytes
        
        You should call Rand() the minimum number of times necessary, 
        concatenate the resulting strings and return the first 'bytes' bytes 
        
        >>> r = Random()
        >>> r.Seed('a "random" test seed')
        >>> IntUtil.bytes2int(r.RandBytes(30))
        1158532743900732463304416053993139858352689716424050676995360884671252453L
        >>> IntUtil.bytes2int(r.RandBytes(47))
        67026168267564133732212770725125633802832090085364621651779444452312790207231683161525919195891674339421127478804L
        """
        pass #STUDENT WORK GOES HERE
    
    def Rand(self):
        """
        Return a random 160 bit string
        
        This string should be generated by finding the hmac-sha1 digest
        of the string value of self.i, which should increment on each call. 
        (The seed is the key) 
        
        >>> r = Random()
        >>> r.Seed('a "random" test seed')
        >>> IntUtil.bytes2int(r.Rand())
        958315824762547815866229678004964546504620380029L
        >>> IntUtil.bytes2int(r.Rand())
        1387065017859281977671838806635380143259831101084L
        >>> IntUtil.bytes2int(r.Rand())
        636451521523350916684092058717442610673630576505L
        """
        pass #STUDENT WORK GOES HERE
   


        
    def RandRange(self,a,b):
        """
        Return a random integer N such that a <= N <= b
        
        You may assume that a < b and a >= 0 and that b - a + 1 <= 2^160-1
        
        You can turn random bytes into an integer using IntUtil.bytes2int()
               
        The resulting bits must have a uniform distribution. This means that 
        you may _NOT_ simply find a large random integer N and compute 
            N %((b+1)-a)+a
            
        Return a number with a uniform distribution and convince us that it's
        uniform by analyzing your approach in a few sentences.
        
        If you plan on using RandDecimal here, think very carefully about the 
        distribution and precision of floating point numbers in Python.
        
        --Delete this text and write your explanation here--


        >>> r = Random()
        >>> r.Seed('a "random" test seed')
        >>> res = []
        >>> for a in range(1,50):
        ...     for b in range(a+1, 50):
        ...         n = r.RandRange(a,b)
        ...         res.append(a <= n and n <= b)
        >>> [i for i in res if not i]
        []
        >>> n = r.RandRange(2,3)
        >>> 2 <= n
        True
        >>> n <= 3
        True

        """
        pass #STUDENT WORK GOES HERE
            


    def RandDecimal(self):
        """
        Return a random number in the range [0.0,1.0)

        >>> r = Random()
        >>> r.Seed('a "random" test seed')
        >>> r.RandDecimal()
        0.65570629569234806
        >>> r.RandDecimal()
        0.94906839816644861
        
        """
        pass #STUDENT WORK GOES HERE
        
if __name__ == "__main__":
    import doctest
    doctest.testmod()    

    #print RSAUtil.ExtendedEuclidean(120,23)
